commit 1423979b276d0e1804fd27526dfc5cfcd83944c7
Author: freddy77 <freddy77>
Date:   Thu Sep 4 06:43:48 2008 +0000

    improve on_server.column_size handling

diff --git a/ChangeLog b/ChangeLog
index 8a93416..b7860eb 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Thu Sep 04 08:42:56 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
+	- fill on_server.column_size
+	* src/odbc/unittests/genparams.c: test for truncation
+	* src/tds/query.c: do not send invalid sizes
+
 Mon Sep 01 17:16:05 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/genparams.c:
 	- reproduce bug detected by Sebastien Flaesch on column size
@@ -602,4 +608,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2598 2008/09/01 15:17:57 freddy77 Exp $
+$Id: ChangeLog,v 1.2599 2008/09/04 06:43:48 freddy77 Exp $
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 095aa4c..9e2be47 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.69 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.70 2008/09/04 06:43:48 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -112,6 +112,7 @@ prepared_rpc(struct _hstmt *stmt, int compute_row)
 				curcol->column_cur_size = curcol->column_size;
 				break;
 			}
+			curcol->on_server.column_size = curcol->column_size;
 			/* TODO support other type other than VARCHAR, do not strip escape in prepare_call */
 			if (compute_row) {
 				char *dest;
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index f3c0317..23b216e 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.70 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.71 2008/09/04 06:43:48 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -178,8 +178,14 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		if (dest_type != SYBUNIQUE && dest_type != SYBBITN && !is_fixed_type(dest_type)) {
 			curcol->column_cur_size = 0;
 			curcol->column_size = drec_ipd->sql_desc_length;
-			if (curcol->column_size < 0)
-				curcol->column_size = 0x7FFFFFFFl;
+			if (curcol->column_size < 0) {
+				curcol->on_server.column_size = curcol->column_size = 0x7FFFFFFFl;
+			} else {
+				if (is_unicode_type(dest_type))
+					curcol->on_server.column_size = curcol->column_size * 2;
+				else
+					curcol->on_server.column_size = curcol->column_size;
+			}
 		}
 	} else if (dest_type != SYBBIT) {
 		/* TODO only a trick... */
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 4ee3ec9..4aaa63d 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -4,7 +4,7 @@
 
 /* Test various type from odbc and to odbc */
 
-static char software_version[] = "$Id: genparams.c,v 1.29 2008/09/01 15:17:57 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.30 2008/09/04 06:43:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -97,6 +97,8 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, SQL
 	Command(Statement, "drop proc spTestProc");
 }
 
+static int check_truncation = 0;
+
 static void
 TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, const char *param_type, const char *value_to_convert)
 {
@@ -146,7 +148,10 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len));
 
 		rc = SQLExecDirect(Statement, (SQLCHAR *) sbuf, SQL_NTS);
-		if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
+		if (check_truncation) {
+			if (rc != SQL_ERROR)
+				ODBC_REPORT_ERROR("SQLExecDirect should return error!");
+		} else if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
 			ODBC_REPORT_ERROR("SQLExecDirect() failure!");
 	} else {
 		SQLRETURN rc;
@@ -160,23 +165,29 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 			CHK(SQLPrepare, (Statement, (SQLCHAR *) sbuf, SQL_NTS));
 
 		rc = SQLExecute(Statement);
-		if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
+		if (check_truncation) {
+			if (rc != SQL_ERROR)
+				ODBC_REPORT_ERROR("SQLExecute should return error!");
+		} else if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
 			ODBC_REPORT_ERROR("SQLExecute() failure!");
 	}
 
 	/* check is row is present */
-	ResetStatement();
-	sep = "'";
-	if (strncmp(expected, "0x", 2) == 0)
-		sep = "";
-	sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, %s%s%s)", param_type, sep, expected, sep);
-	Command(Statement, sbuf);
-
-	CHK(SQLFetch, (Statement));
-	if (SQLFetch(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Row not expected");
-	if (SQLMoreResults(Statement) != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("Recordset not expected");
+	if (!check_truncation) {
+		ResetStatement();
+		sep = "'";
+		if (strncmp(expected, "0x", 2) == 0)
+			sep = "";
+		sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, %s%s%s)", param_type, sep, expected, sep);
+		Command(Statement, sbuf);
+
+		CHK(SQLFetch, (Statement));
+		if (SQLFetch(Statement) != SQL_NO_DATA)
+			ODBC_REPORT_ERROR("Row not expected");
+		if (SQLMoreResults(Statement) != SQL_NO_DATA)
+			ODBC_REPORT_ERROR("Recordset not expected");
+	}
+	check_truncation = 0;
 	Command(Statement, "DROP TABLE #tmp_insert");
 }
 
@@ -283,6 +294,7 @@ AllTests(void)
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "test");
 		/* test for invalid stream due to truncation*/
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "01234567890");
+		check_truncation = 1;
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "012345678901234567890");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "\xa3h\xf9 -> 0xA3006800f900");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "0xA3006800f900 -> \xa3h\xf9");
diff --git a/src/tds/query.c b/src/tds/query.c
index 134b7ca..583ae88 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.225 2008/08/22 05:27:22 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.226 2008/09/04 06:43:49 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -1273,6 +1273,44 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 	return tds_flush_packet(tds);
 }
 
+/**
+ * Get column size for wire
+ */
+static int
+tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol)
+{
+	int size = curcol->on_server.column_size, min;
+
+	if (!size) {
+		size = curcol->column_size;
+		if (is_unicode_type(curcol->on_server.column_type))
+			size *= 2;
+	}
+
+	switch (curcol->column_varint_size) {
+	default:
+	case 0:
+		return size;
+	case 1:
+		size = MAX(MIN(size, 255), 1);
+		break;
+	case 2:
+		if (curcol->on_server.column_type == XSYBNVARCHAR || curcol->on_server.column_type == XSYBNCHAR)
+			min = 2;
+		else
+			min = 1;
+		size = MAX(MIN(size, 8000), min);
+		break;
+	case 4:
+		if (curcol->on_server.column_type == SYBNTEXT)
+			size = MAX(MIN(size, 0x7ffffffe), 2);
+		else
+			size = MAX(MIN(size, 0x7fffffff), 1);
+		break;
+	}
+/*	return curcol->on_server.column_size = size; */
+	return size;
+}
 
 /**
  * Put data information to wire
@@ -1343,17 +1381,18 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 		tds_put_byte(tds, num->scale);
 #endif
 	} else {
+		int size = tds_fix_column_size(tds, curcol);
 		switch (curcol->column_varint_size) {
 		case 0:
 			break;
 		case 1:
-			tds_put_byte(tds, MAX(MIN(curcol->column_size, 255), 1));
+			tds_put_byte(tds, size);
 			break;
 		case 2:
-			tds_put_smallint(tds, MAX(MIN(curcol->column_size, 8000), 1));
+			tds_put_smallint(tds, size);
 			break;
 		case 4:
-			tds_put_int(tds, MAX(MIN(curcol->column_size, 0x7fffffff), 1));
+			tds_put_int(tds, size);
 			break;
 		}
 	}
@@ -1411,7 +1450,7 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	unsigned char *src;
 	TDS_NUMERIC *num;
 	TDSBLOB *blob = NULL;
-	TDS_INT colsize;
+	TDS_INT colsize, size;
 
 	CHECK_TDS_EXTRA(tds);
 	CHECK_COLUMN_EXTRA(curcol);
@@ -1439,6 +1478,8 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		return TDS_SUCCEED;
 	}
 
+	size = tds_fix_column_size(tds, curcol);
+
 	/*
 	 * TODO here we limit data sent with MIN, should mark somewhere
 	 * and inform client ??
@@ -1483,18 +1524,18 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		switch (curcol->column_varint_size) {
 		case 4:	/* It's a BLOB... */
 			blob = (TDSBLOB *) curcol->column_data;
-			colsize = MIN(colsize, 0x7fffffff);
+			colsize = MIN(colsize, size);
 			/* mssql require only size */
 			tds_put_int(tds, colsize);
 			break;
 		case 2:
-			colsize = MIN(colsize, 8000);
+			colsize = MIN(colsize, size);
 			tds_put_smallint(tds, colsize);
 			break;
 		case 1:
+			colsize = MIN(colsize, size);
 			if (is_numeric_type(curcol->on_server.column_type))
 				colsize = tds_numeric_bytes_per_prec[((TDS_NUMERIC *) src)->precision];
-			colsize = MIN(colsize, 255);
 			tds_put_byte(tds, colsize);
 			break;
 		case 0:

